#include <Servo.h>

Servo servo1; 
Servo servo2;
Servo servo3;

const int RedLed = 2; 
const int RedLed1 = 3;
const int RedLed2 = 4;
const int RedLed3 = 7;
const int RedLed4 = 8;

const int PushButton = 12;
const int PushButton1 = 13;

int buttonPresses = 0; 
boolean buttonPressed = false;

const int pot1 = A0; 
const int pot2 = A1; 
const int pot3 = A2;

int Pot1Value; 
int Pot2Value;
int Pot3Value;
int Pot1Ang;
int Pot2Ang;
int Pot3Ang;

int servo1PosSaves[] = {1,1,1,1,1}; 
int servo2PosSaves[] = {1,1,1,1,1};
int servo3PosSaves[] = {1,1,1,1,1};

void setup() {
  servo1.attach(5); 
  servo2.attach(6);
  servo3.attach(9);
  
  pinMode(RedLed, OUTPUT);
  pinMode(RedLed1, OUTPUT);
  pinMode(RedLed2, OUTPUT);
  pinMode(RedLed3, OUTPUT);
  pinMode(RedLed4, OUTPUT);
  pinMode(PushButton, INPUT);
  pinMode(PushButton1, INPUT);

  Serial.begin(9600);
}

void loop() {
  Pot1Value = analogRead(pot1); 
  Pot1Ang = map(Pot1Value, 0, 1023, 0, 179);
  Pot2Value = analogRead(pot2); 
  Pot2Ang = map(Pot2Value, 0, 1023, 0, 179);
  Pot3Value = analogRead(pot3);
  Pot3Ang = map(Pot3Value, 0, 1023, 0, 179);
  
  servo1.write(Pot1Ang); 
  servo2.write(Pot2Ang);
  servo3.write(Pot3Ang);
  
  if(digitalRead(PushButton) == HIGH){
    buttonPresses++;
    switch(buttonPresses){
      case 1:
        servo1PosSaves[0] = Pot1Ang;
        servo2PosSaves[0] = Pot2Ang;
        servo3PosSaves[0] = Pot3Ang;
        digitalWrite(RedLed, HIGH);
        Serial.println("Position 1 Saved");
        break;
      case 2:
         servo1PosSaves[1] = Pot1Ang;
         servo2PosSaves[1] = Pot2Ang;
         servo3PosSaves[1] = Pot3Ang;
         digitalWrite(RedLed1, HIGH);
         Serial.println("Position 2 Saved");
         break;
      case 3:
         servo1PosSaves[2] = Pot1Ang;
         servo2PosSaves[2] = Pot2Ang;
         servo3PosSaves[2] = Pot3Ang;
         digitalWrite(RedLed2, HIGH);
         Serial.println("Position 3 Saved");
         break;
       case 4:
         servo1PosSaves[3] = Pot1Ang;
         servo2PosSaves[3] = Pot2Ang;
         servo3PosSaves[3] = Pot3Ang;
         digitalWrite(RedLed3, HIGH);
         Serial.println("Position 4 Saved");
         break;
       case 5:
         servo1PosSaves[4] = Pot1Ang;
         servo2PosSaves[4] = Pot2Ang;
         servo3PosSaves[4] = Pot3Ang;
         digitalWrite(RedLed4, HIGH);
         Serial.println("Position 5 Saved");
         break;
    }
  }

  if(digitalRead(PushButton1) == HIGH){ 
    buttonPressed = true;   
  }
  
  if(buttonPressed){ 
    for(int i = 0; i < 5; i++){
        servo1.write(servo1PosSaves[i]);
        servo2.write(servo2PosSaves[i]);
        servo3.write(servo3PosSaves[i]);
        Serial.println(" Pot Angles: ");
        Serial.println(servo1PosSaves[i]);
        Serial.println(servo2PosSaves[i]);
        Serial.println(servo3PosSaves[i]);
        delay(1050);
      }
  }
  delay(300);
} 
